      subroutine icf(n, nmax, p, x, diag, a, ia,
     +     ja,ta,info, itcol, ifirst, list, sqinvD, 
     +     alpha, pretime1, pretime2, pretime3)
      integer n, p, info, nmax
      integer ia(n+1),ja(*),itcol(n),ifirst(n),list(n)
      double precision diag(n),a(*),ta(*), x(nmax, *)
      double precision sqinvD(*), alpha
      double precision pretime1, pretime2, pretime3

c     This subroutine does incomplete factorization of 
c     dense mattrices from

c     Subroutines used 

      external ibsort, dbsort, dhsort

c     Variables used

      integer isj, iej, newisk, newiek
      integer i, j, k 
      integer talen
      integer row, count
      double precision lval
      integer iptr

c     New variable for getting the k-th column

      double precision timeSt, timeEd

      do j = 1, n
         ifirst(j) = 0
         list(j) = 0
         diag(j) = 0
      end do

      ia(1) = 1

c     Loop over all columns

      do k = 1,n

c        Get the k-th column

         call dtimer(timeSt)

         do j1 = k, n
            ta(j1) = x(j1, k) 
         end do

c        Scaling data

         do j1 = k, n
            ta(j1) = sqinvD(k)*ta(j1)*sqinvD(j1)
         end do 
         diag(k) =  diag(k) + ta(k) + alpha

         call dtimer(timeEd)
         pretime1 = pretime1 + timeEd - timeSt

         call dtimer(timeSt)     
         talen = 0
         do 20 j = k+1, n
            talen = talen + 1
            itcol(talen) = j
            ifirst(j) = 1
 20      continue
         
c        Make sure the k'th diagonal element is okay and then take the sqrt
         
	 if (diag(k).le.0.0d0) then
            
c           If an error occured, return a negative value
            
            info = -k
            write (*,*) 'negative diagonal ', k

	    return
            
	 endif
	 diag(k) = sqrt(diag(k))

c        Update column k using the previous columns
         
	 j = list(k)
 30	 continue
	 if (j.ne.0) then
	    isj = ifirst(j)
	    iej = ia(j+1)-1
	    lval = a(isj)
	    isj = isj + 1
	    if (isj.lt.iej) then
               ifirst(j) = isj
               iptr = j
               j = list(j)
               list(iptr) = list(ja(isj))
               list(ja(isj)) = iptr
	    else
               j = list(j)
	    endif
	    do i = isj, iej
               row = ja(i)
               if (ifirst(row).ne.0) then
                  ta(row) = ta(row) - lval*a(i)
               else
                  ifirst(row) = 1
                  talen = talen + 1
                  itcol(talen) = row
                  ta(row) = - lval*a(i)
               endif
            end do
	    go to 30
	 endif
         
c        Update remaining diagonals using column k
         
	 do j = 1, talen
	    row = itcol(j)
	    ta(row) = ta(row)/diag(k)
	    diag(row) = diag(row) - ta(row)*ta(row)
         end do

         call dtimer(timeEd)     
         pretime2 = pretime2 + timeEd - timeSt


         call dtimer(timeSt)

c        Find the largest elements in column k now
         
	 count = min(p,talen)
	 call ibsort(talen,count,ta,itcol)

	 if (count.lt.20) then
	    call dbsort(count,itcol)
	 else
	    call dhsort(count,itcol)
	 endif
         call dtimer(timeEd)
         pretime3 = pretime3 + timeEd - timeSt

         call dtimer(timeSt)     
	 newisk = ia(k)
	 newiek = newisk + count -1
	 count = 1
	 do j = newisk, newiek
	    a(j) = ta(itcol(count))
	    ja(j) = itcol(count)
	    count = count + 1
         end do
         
c        ifirst and list keep track of where in column k we are
         
	 if (newisk.lt.newiek) then
	    iptr = ja(newisk)
	    list(k) = list(iptr)
	    list(iptr) = k
	    ifirst(k) = newisk
	 endif
         
	 do j = 1, talen
	    ifirst(itcol(j)) = 0
         end do
         
         ia(k+1) = newiek + 1

         call dtimer(timeEd)     
         pretime2 = pretime2 + timeEd - timeSt


      end do
      
      info = 0

      return

      end
